#! /usr/bin/python


import os
import subprocess

from monitorupgrade import TLog as TLOG

#globals
UP_RPMS_DIR = '/opt/toshiba/mus/RpmUpdates'
INSTALLED_UP_RPMS_DIR = '/opt/toshiba/mus/ProcessedRpms'

def runShell(cmd):
    
    TLOG.logger.info('runShell: ' + cmd)    
    process = subprocess.Popen(cmd, shell=True, stdout=subprocess.PIPE)
    while True:
        line = process.stdout.readline()
        #print line
        if not line:
            break
        #TLOG.logger.info('boot_update::runShell(): ' + line )    
    process.wait()

    return process.returncode


def installrpm(pkg):
    cmd = 'rpm -ivh' + ' ' + str(pkg)
    ret = runShell(cmd)
    
    if(ret == 0):
        #print pkg, '------installation[ OK ]'
        TLOG.logger.info(pkg + ' ------installation[ OK ]')
        if os.path.exists(INSTALLED_UP_RPMS_DIR):
            movePkg(pkg)
        else:
            
            runShell('mkdir' + ' ' + INSTALLED_UP_RPMS_DIR) 
            movePkg(pkg)
    else:
        TLOG.logger.info(pkg + ' ------installation[ FAIL ]')
        #print pkg, '------installation[FAIL]' 

def removehistory():
    cmd = 'rm -f rpm-installed-ups1.1 /tmp/rpm-name'
    runShell(cmd)

def movePkg(pkg):
    cmd = 'mv ' + str(pkg) + ' ' + INSTALLED_UP_RPMS_DIR
    runShell(cmd)
    
def getPackageName(pkg):
    name=''
    cmd = 'rpm -qpil ' + pkg + '| grep Name > /tmp/rpm-name'
    ret = runShell(cmd)
    if ret == 0:
        f = open('/tmp/rpm-name', 'r+')
        line = f.readline()
        f.close()
        line = str(line)
        name = line[13:-31]
        name = name.strip(' ')
    
    return name

def getPackageVersion(pkg):
    ver=''
    cmd = 'rpm -qpil ' + pkg + '| grep Version > pkg-ver'
    ret = runShell(cmd)
    if ret == 0:
        f = open('pkg-ver', 'r+')
        line = f.readline()
        f.close()
        line = str(line)
        ver = line[13:17]
        ver = ver.strip(' ')
    
    return ver

def getRelease(pkg):
    rel=''
    cmd = 'rpm -qpil ' + pkg + '| grep Release > rel-ver'
    ret = runShell(cmd)
    if ret == 0:
        f = open('rel-ver', 'r+')
        line = f.readline()
        f.close()
        line = str(line)
        rel = line[13:15]
        rel = rel.strip(' ')
    
    return rel

            
def isValidName(name):
    
    if 'toshiba-mus1.1_up' in name:
        return True
    elif 'toshiba-mus2.0_up' in name:
        return True
    else:
        return False
    
def process():
    cmd = 'rpm -qa | grep toshiba-mus2.0_up > /tmp/rpm-installed-ups2.0'
    #print cmd
    runShell(cmd) 
    for root, dirs, files in os.walk(UP_RPMS_DIR, topdown=False):
        for name in files:        
            pkg = (os.path.join(root, name))
            #name_len = len(name)
            #name = name[:name_len - 11]
            true_name = getPackageName(pkg)
            ver  = getPackageVersion(pkg)
            rel  = getRelease(pkg)
            #print pkg
            #print name
            true_pkg_name = true_name + '-' + ver + '-' + rel
            
            if not pkg.endswith('.rpm'):
                #print pkg
                continue
            
            if not isValidName(name):
                TLOG.logger.info(name + ' is not a valid UP')
                continue
            
            f = open('/tmp/rpm-installed-ups2.0', 'r+')
            filenames = f.readlines()
            count = len(filenames)
            found = False
            if (count == 0) :
                installrpm(pkg)
              
            else:
                
                for rpm_name in filenames:
                    #print name,rpm_name
                    if true_pkg_name == rpm_name.strip('\n'):
                        found = True
                
                if (found == False):
                    installrpm(pkg)                        
                else:
                    print true_pkg_name, 'is already installed'
                    TLOG.logger.info(name + ' is already installed')
                    movePkg(pkg)
                       

    removehistory()


